/* Copyright (c) 2015 Asustor Inc. All rights reserved. */

Ext.ns('AS.ARC.onedrive');

Ext.define('AS.ARC.onedrive.FilterSet', {
    extend: 'Ext.form.FieldSet',
    itemId: 'filterSet',
    imageUrl: AS.ARC.util.getUserAppsPath() + 'onedrive/images/',
    height: 250,
    autoScroll: true,
    title: _S('ONEDRIVE', 'FILE_FILTER'),
    defaults: {
        margin: '5 0 0 0'
    },

    initComponent: function() {
        var fn = this;
        var document = ['*.doc', '*.docx', '*.xls', '*.xlsx', '*.ppt', '*.pptx', '*.xlr', '*.txt', '*.pdf', '*.csv', '*.mpp', '*.vsd', '*.pps'];
        var video = ['*.avi', '*.flv', '*.mov', '*.mpg', '*.mpeg', '*.mkv', '*.rmvb', '*.swf', '*.wmv'];		
        var music = ['*.amr', '*.awb', '*.acc', '*.mp3', '*.m4a', '*.m4p', '*.dss', '*.dvf', '*.wav', '*.wma'];
        var photo = ['*.bmp', '*.tif', '*.jpg', '*.gif', '*.png', '*.eps', '*.ai', '*.svg', '*.obj'];
        var application = ['*.app', '*.clg', '*.com', '*.gadgt', '*.jar', '*.pif', '*.vb', '*.wsf'];
        var documentCbs = [];
        var videoCbs = [];
        var musicCbs = [];
        var photoCbs = [];
        var applicationCbs = [];

        for (var i = 0; i < document.length; i ++) {

                        documentCbs.push({
                                xtype: 'checkbox',
                                width: 500,
                                boxLabel: document[i],
                                handler: function(checkbox, checked) {
                                    var selectAllCb = checkbox.ownerCt.ownerCt.items.get('ct1').items.get('select_all');
                                    var checkAllTrue = true;
                                    var checkCount = 0;
                                    selectAllCb.removeCls('gray-checkbox');
                                    for (var i = 0; i < checkbox.ownerCt.query('checkbox').length; i ++) {
                                        if (!checkbox.ownerCt.query('checkbox')[i].getValue()) {
                                            checkAllTrue = false;
                                        } else {
                                            checkCount += 1;
                                        }
                                    }
                                    if (checkAllTrue == true) {
                                        selectAllCb.setValue(true);
                                    } else {
                                        if(checkCount) {
                                            selectAllCb.addCls('gray-checkbox');
                                        }
                                        selectAllCb.setRawValue(false);
                                        selectAllCb.lastValue = false;
                                    }
                                }
                            });

        }

        for (var i = 0; i < video.length; i ++) {
                        videoCbs.push({
                                xtype: 'checkbox',
                                width: 500,
                                boxLabel: video[i],
                                handler: function(checkbox, checked) {
                                    var selectAllCb = checkbox.ownerCt.ownerCt.items.get('ct1').items.get('select_all');
                                    var checkAllTrue = true;
                                    var checkCount = 0;
                                    selectAllCb.removeCls('gray-checkbox');
                                    for (var i = 0; i < checkbox.ownerCt.query('checkbox').length; i ++) {
                                        if (!checkbox.ownerCt.query('checkbox')[i].getValue()) {
                                            checkAllTrue = false;
                                        } else {
                                            checkCount += 1;
                                        }
                                    }
                                    if (checkAllTrue == true) {
                                        selectAllCb.setValue(true);
                                    } else {
                                        if(checkCount) {
                                            selectAllCb.addCls('gray-checkbox');
                                        }
                                        selectAllCb.setRawValue(false);
                                        selectAllCb.lastValue = false;
                                    }
                                }
                            });
        }

        for (var i = 0; i < music.length; i ++) {
                        musicCbs.push({
                                xtype: 'checkbox',
                                width: 500,
                                boxLabel: music[i],
                                handler: function(checkbox, checked) {
                                    var selectAllCb = checkbox.ownerCt.ownerCt.items.get('ct1').items.get('select_all');
                                    var checkAllTrue = true;
                                    var checkCount = 0;
                                    selectAllCb.removeCls('gray-checkbox');
                                    for (var i = 0; i < checkbox.ownerCt.query('checkbox').length; i ++) {
                                        if (!checkbox.ownerCt.query('checkbox')[i].getValue()) {
                                            checkAllTrue = false;
                                        } else {
                                            checkCount += 1;
                                        }
                                    }
                                    if (checkAllTrue == true) {
                                        selectAllCb.setValue(true);
                                    } else {
                                        if(checkCount) {
                                            selectAllCb.addCls('gray-checkbox');
                                        }
                                        selectAllCb.setRawValue(false);
                                        selectAllCb.lastValue = false;
                                    }
                                }
                            });
        }

        for (var i = 0; i < photo.length; i ++) {
                        photoCbs.push({
                                xtype: 'checkbox',
                                width: 500,
                                boxLabel: photo[i],
                                handler: function(checkbox, checked) {
                                    var selectAllCb = checkbox.ownerCt.ownerCt.items.get('ct1').items.get('select_all');
                                    var checkAllTrue = true;
                                    var checkCount = 0;
                                    selectAllCb.removeCls('gray-checkbox');
                                    for (var i = 0; i < checkbox.ownerCt.query('checkbox').length; i ++) {
                                        if (!checkbox.ownerCt.query('checkbox')[i].getValue()) {
                                            checkAllTrue = false;
                                        } else {
                                            checkCount += 1;
                                        }
                                    }
                                    if (checkAllTrue == true) {
                                        selectAllCb.setValue(true);
                                    } else {
                                        if(checkCount) {
                                            selectAllCb.addCls('gray-checkbox');
                                        }
                                        selectAllCb.setRawValue(false);
                                        selectAllCb.lastValue = false;
                                    }
                                }
                            });
        }

        for (var i = 0; i < application.length; i ++) {
                        applicationCbs.push({
                                xtype: 'checkbox',
                                width: 500,
                                boxLabel: application[i],
                                handler: function(checkbox, checked) {
                                    var selectAllCb = checkbox.ownerCt.ownerCt.items.get('ct1').items.get('select_all');
                                    var checkAllTrue = true;
                                    var checkCount = 0;
                                    selectAllCb.removeCls('gray-checkbox');
                                    for (var i = 0; i < checkbox.ownerCt.query('checkbox').length; i ++) {
                                        if (!checkbox.ownerCt.query('checkbox')[i].getValue()) {
                                            checkAllTrue = false;
                                        } else {
                                            checkCount += 1;
                                        }
                                    }
                                    if (checkAllTrue == true) {
                                        selectAllCb.setValue(true);
                                    } else {
                                        if(checkCount) {
                                            selectAllCb.addCls('gray-checkbox');
                                        }
                                        selectAllCb.setRawValue(false);
                                        selectAllCb.lastValue = false;
                                    }
                                }
                            });
        }
        fn.items = [
                {
                    xtype: 'container',
                    itemId: 'documentCt',
                    width: 500,
                    items: [
                        {
                            xtype: 'container',
                            itemId: 'ct1',
                            layout: 'hbox',
                            width: 500,
                            items: [
                                {
                                    xtype: 'image',
                                    width: 17,
                                    height: 17,
                                    style: 'cursor: pointer;',
                                    src: fn.imageUrl + 'arrow.png',
                                    listeners: {
                                        render: function(img) {
                                            img.getEl().on('click', function() {
                                                var ct2 = img.ownerCt.next();
                                                if (ct2.hidden == true || ct2.el.dom.hidden == true) {
                                                    img.setSrc(fn.imageUrl + 'arrow_down.png');
                                                    ct2.show();
                                                } else {
                                                    img.setSrc(fn.imageUrl + 'arrow.png');
                                                    ct2.hide();
                                                }
                                            });
                                        }
                                    }
                                },
                                {
                                    xtype: 'checkbox',
                                    itemId: 'select_all',
                                    margin: '0 0 0 7',
                                    handler: function(checkbox, checked) {

                                        if (checked) {
                                            for (var i = 0; i < checkbox.ownerCt.ownerCt.items.get('ct2').query('checkbox').length; i ++) {
                                                checkbox.ownerCt.ownerCt.items.get('ct2').query('checkbox')[i].setValue(true);
                                            }
                                        } else {
                                            for (var i = 0; i < checkbox.ownerCt.ownerCt.items.get('ct2').query('checkbox').length; i ++) {
                                                checkbox.ownerCt.ownerCt.items.get('ct2').query('checkbox')[i].setValue(false);
                                            }
                                        }

                                    }
                                },
                                {
                                    xtype: 'displayfield',
                                    margin: '0 0 0 7',
                                    width: 300,
                                    fieldLabel: _S('ONEDRIVE', 'DOCUMENT')
                                }
                            ]
                        }, 
                        {
                            xtype: 'container',
                            itemId: 'ct2',
                            width: 500,
                            hidden: true,
                            margin: '5 0 0 60',
                            items: documentCbs

                        }
                    ]
                }, 
                {
                    xtype: 'container',
                    itemId: 'videoCt',
                    width: 500,
                    items: [
                        {
                            xtype: 'container',
                            itemId: 'ct1',
                            layout: 'hbox',
                            width: 500,
                            items: [
                                {
                                    xtype: 'image',
                                    width: 17,
                                    height: 17,
                                    style: 'cursor: pointer;',
                                    src: fn.imageUrl + 'arrow.png',
                                    listeners: {
                                        render: function(img) {
                                            img.getEl().on('click', function() {
                                                var ct2 = img.ownerCt.next();
                                                if (ct2.hidden == true || ct2.el.dom.hidden == true) {
                                                    img.setSrc(fn.imageUrl + 'arrow_down.png');
                                                    ct2.show();
                                                } else {
                                                    img.setSrc(fn.imageUrl + 'arrow.png');
                                                    ct2.hide();
                                                }
                                            });
                                        }
                                    }
                                },
                                {
                                    xtype: 'checkbox',
                                    itemId: 'select_all',
                                    margin: '0 0 0 7',
                                    handler: function(checkbox, checked) {

                                        if (checked) {
                                            for (var i = 0; i < checkbox.ownerCt.ownerCt.items.get('ct2').query('checkbox').length; i ++) {
                                                checkbox.ownerCt.ownerCt.items.get('ct2').query('checkbox')[i].setValue(true);
                                            }
                                        } else {
                                            for (var i = 0; i < checkbox.ownerCt.ownerCt.items.get('ct2').query('checkbox').length; i ++) {
                                                checkbox.ownerCt.ownerCt.items.get('ct2').query('checkbox')[i].setValue(false);
                                            }
                                        }

                                    }
                                },
                                {
                                    xtype: 'displayfield',
                                    margin: '0 0 0 7',
                                    width: 300,
                                    fieldLabel: _S('ONEDRIVE', 'VIDEO')
                                }
                            ]
                        },
                        {
                            xtype: 'container',
                            itemId: 'ct2',
                            width: 500,
                            hidden: true,
                            margin: '5 0 0 60',
                            items: videoCbs

                        }
                    ]
                }, {
                    xtype: 'container',
                    itemId: 'musicCt',
                    width: 500,
                    items: [
                        {
                            xtype: 'container',
                            itemId: 'ct1',
                            layout: 'hbox',
                            width: 500,
                            items: [
                                {
                                    xtype: 'image',
                                    width: 17,
                                    height: 17,
                                    style: 'cursor: pointer;',
                                    src: fn.imageUrl + 'arrow.png',
                                    listeners: {
                                        render: function(img) {
                                            img.getEl().on('click', function() {
                                                var ct2 = img.ownerCt.next();
                                                if (ct2.hidden == true || ct2.el.dom.hidden == true) {
                                                    img.setSrc(fn.imageUrl + 'arrow_down.png');
                                                    ct2.show();
                                                } else {
                                                    img.setSrc(fn.imageUrl + 'arrow.png');
                                                    ct2.hide();
                                                }
                                            });
                                        }
                                    }
                                },
                                {
                                    xtype: 'checkbox',
                                    itemId: 'select_all',
                                    margin: '0 0 0 7',
                                    handler: function(checkbox, checked) {

                                        if (checked) {
                                            for (var i = 0; i < checkbox.ownerCt.ownerCt.items.get('ct2').query('checkbox').length; i ++) {
                                                checkbox.ownerCt.ownerCt.items.get('ct2').query('checkbox')[i].setValue(true);
                                            }
                                        } else {
                                            for (var i = 0; i < checkbox.ownerCt.ownerCt.items.get('ct2').query('checkbox').length; i ++) {
                                                checkbox.ownerCt.ownerCt.items.get('ct2').query('checkbox')[i].setValue(false);
                                            }
                                        }

                                    }
                                },
                                {
                                    xtype: 'displayfield',
                                    margin: '0 0 0 7',
                                    width: 300,
                                    fieldLabel: _S('ONEDRIVE', 'MUSIC')
                                }
                            ]
                        },
                        {
                            xtype: 'container',
                            itemId: 'ct2',
                            width: 500,
                            hidden: true,
                            margin: '5 0 0 60',
                            items: musicCbs
                        }
                    ]
                },
                {
                    xtype: 'container',
                    itemId: 'photoCt',
                    width: 500,
                    items: [
                        {
                            xtype: 'container',
                            itemId: 'ct1',
                            layout: 'hbox',
                            width: 500,
                            items: [
                                {
                                    xtype: 'image',
                                    width: 17,
                                    height: 17,
                                    style: 'cursor: pointer;',
                                    src: fn.imageUrl + 'arrow.png',
                                    listeners: {
                                        render: function(img) {
                                            img.getEl().on('click', function() {
                                                var ct2 = img.ownerCt.next();
                                                if (ct2.hidden == true || ct2.el.dom.hidden == true) {
                                                    img.setSrc(fn.imageUrl + 'arrow_down.png');
                                                    ct2.show();
                                                } else {
                                                    img.setSrc(fn.imageUrl + 'arrow.png');
                                                    ct2.hide();
                                                }
                                            });
                                        }
                                    }
                                },
                                {
                                    xtype: 'checkbox',
                                    itemId: 'select_all',
                                    margin: '0 0 0 7',
                                    handler: function(checkbox, checked) {

                                        if (checked) {
                                            for (var i = 0; i < checkbox.ownerCt.ownerCt.items.get('ct2').query('checkbox').length; i ++) {
                                                checkbox.ownerCt.ownerCt.items.get('ct2').query('checkbox')[i].setValue(true);
                                            }
                                        } else {
                                            for (var i = 0; i < checkbox.ownerCt.ownerCt.items.get('ct2').query('checkbox').length; i ++) {
                                                checkbox.ownerCt.ownerCt.items.get('ct2').query('checkbox')[i].setValue(false);
                                            }
                                        }

                                    }
                                },
                                {
                                    xtype: 'displayfield',
                                    margin: '0 0 0 7',
                                    width: 300,
                                    fieldLabel: _S('ONEDRIVE', 'PHOTO')
                                }
                            ]
                        },
                        {
                            xtype: 'container',
                            itemId: 'ct2',
                            width: 500,
                            hidden: true,
                            margin: '5 0 0 60',
                            items: photoCbs

                        }
                    ]
                },
                {
                    xtype: 'container',
                    itemId: 'applicationCt',
                    width: 500,
                    items: [
                        {
                            xtype: 'container',
                            itemId: 'ct1',
                            layout: 'hbox',
                            width: 500,
                            items: [
                                {
                                    xtype: 'image',
                                    width: 17,
                                    height: 17,
                                    style: 'cursor: pointer;',
                                    src: fn.imageUrl + 'arrow.png',
                                    listeners: {
                                        render: function(img) {
                                            img.getEl().on('click', function() {
                                                var ct2 = img.ownerCt.next();
                                                if (ct2.hidden == true || ct2.el.dom.hidden == true) {
                                                    img.setSrc(fn.imageUrl + 'arrow_down.png');
                                                    ct2.show();
                                                } else {
                                                    img.setSrc(fn.imageUrl + 'arrow.png');
                                                    ct2.hide();
                                                }
                                            });
                                        }
                                    }
                                },
                                {
                                    xtype: 'checkbox',
                                    itemId: 'select_all',
                                    margin: '0 0 0 7',
                                    handler: function(checkbox, checked) {

                                        if (checked) {
                                            for (var i = 0; i < checkbox.ownerCt.ownerCt.items.get('ct2').query('checkbox').length; i ++) {
                                                checkbox.ownerCt.ownerCt.items.get('ct2').query('checkbox')[i].setValue(true);
                                            }
                                        } else {
                                            for (var i = 0; i < checkbox.ownerCt.ownerCt.items.get('ct2').query('checkbox').length; i ++) {
                                                checkbox.ownerCt.ownerCt.items.get('ct2').query('checkbox')[i].setValue(false);
                                            }
                                        }

                                    }
                                },
                                {
                                    xtype: 'displayfield',
                                    margin: '0 0 0 7',
                                    width: 300,
                                    fieldLabel: _S('ONEDRIVE', 'APPLICATION')
                                }
                            ]
                        },
                        {
                            xtype: 'container',
                            itemId: 'ct2',
                            width: 500,
                            hidden: true,
                            margin: '5 0 0 60',
                            items: applicationCbs

                        }
                    ]
                },
                {
                    xtype: 'container',
                    itemId: 'customCt',
                    width: 450,
                    items: [
                        {
                            xtype: 'container',
                            itemId: 'ct1',
                            layout: 'hbox',
                            width: 500,
                            items: [
                                {
                                    xtype: 'image',
                                    width: 17,
                                    height: 17,
                                    style: 'cursor: pointer;',
                                    src: fn.imageUrl + 'arrow_down.png',
                                    listeners: {
                                        render: function(img) {
                                            img.getEl().on('click', function() {
                                                var ct2 = img.ownerCt.next();
                                                if (ct2.hidden == true || ct2.el.dom.hidden == true) {
                                                    img.setSrc(fn.imageUrl + 'arrow_down.png');
                                                    ct2.show();
                                                } else {
                                                    img.setSrc(fn.imageUrl + 'arrow.png');
                                                    ct2.hide();
                                                }
                                            });
                                        }
                                    }
                                },
                                {
                                    xtype: 'checkbox',
                                    itemId: 'select_all',
                                    margin: '0 0 0 7',
                                    handler: function(checkbox, checked) {

                                        if (checked) {
                                            for (var i = 0; i < checkbox.ownerCt.ownerCt.items.get('ct2').query('checkbox').length; i ++) {
                                                checkbox.ownerCt.ownerCt.items.get('ct2').query('checkbox')[i].setValue(true);
                                            }
                                        } else {
                                            for (var i = 0; i < checkbox.ownerCt.ownerCt.items.get('ct2').query('checkbox').length; i ++) {
                                                checkbox.ownerCt.ownerCt.items.get('ct2').query('checkbox')[i].setValue(false);
                                            }
                                        }

                                    }
                                },
                                {
                                    xtype: 'displayfield',
                                    margin: '0 0 0 7',
                                    width: 300,
                                    fieldLabel: _S('DEFENDER', 'CUSTOMIZED')
                                }
                            ]
                        },
                        {
                            xtype: 'container',
                            itemId: 'ct2',
                            width: 500,
                            hidden: false,
                            autoScroll: true,
                            margin: '5 0 0 60',
                            style: 'margin-left: 20px;'

                        }
                    ]
                }



            ];


        fn.callParent();

    }

});

/**
 * @class AS.ARC.apps.onedrive.core
 * @extends Ext.util.Observable
 * <p>core</p>
 */

Ext.define('AS.ARC.apps.onedrive.core', {
	extend: 'Ext.util.Observable',

	apiUrl: AS.ARC.util.getUserAppsPath() + 'onedrive/onedrive.cgi',
	imageUrl: AS.ARC.util.getUserAppsPath() + 'onedrive/images/',

	constructor: function (config) {
		Ext.apply(this, config);

		this.callParent();

		this.init();
	},

	init: function () {
		var fn = this;

		fn.win = fn.desktop.createWindow({
			app: fn.app,
			id: fn.id,
			itemId: fn.id,
			width: 880,
			height: 520,
			resizable: false,
			border: false,
			layout: 'border',
			bodyStyle: 'padding: 0; border: none; background: #FFFFFF;',
			items: [
				fn.getMainPanel(),
				fn.getWestPanel()
			],
			listeners: {
				afterrender: function (win) {
					win.header.items.items[1].hide();
					fn.win.el.mask(_S('COMMON','LOADING'));
					
					// when open app check login
					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act: 'check_login'}),
						method: 'post',
						success: function (json, opts) {
							
							fn.mainPanel.loadData();
							
						},
						failure: function (json, opts) {
							AS.ARC.util.showMsgWindow({
			                    5022: _S('ONEDRIVE', 'FILE_IS_BUSY'),
			                    5402: _S('ONEDRIVE', 'OUT_OF_MEMORY'),
			                }, json, fn.win);
						}
					});
				}
			}

		});
	},

	// To check if unlink or network disconnect
	connCounter: {
		times: 0,
		add: function () {
			this.times ++;
		},
		get: function () {
			return this.times;
		},
		clear: function () {
			this.times = 0;
		}
	},
	//取得用戶資料
	getStatus : function () {
		var fn = this;
		AS.ARC.ajax({
			url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act: 'status'}),
			method: 'post',
			success: function (json, opts) {
				fn.accountPanel.items.get('fs').items.get('status').setValue(json.status);
				fn.status = setTimeout(function () {
					fn.getStatus();
				}, 5000);

				fn.accountPanel.items.get('title').items.get('start').hide();
				fn.accountPanel.items.get('title').items.get('stop').show();
			},
			failure: function (json, opts) {
				fn.accountPanel.items.get('fs').items.get('status').setValue(AS.ARC.datas.defaultValue);
				fn.status = setTimeout(function () {
					fn.getStatus();
				}, 5000);

				fn.accountPanel.items.get('title').items.get('start').show();
				fn.accountPanel.items.get('title').items.get('stop').hide();
			}
		});
	},

	getWestPanel: function () {
		var fn = this;

		fn.westPanel = Ext.create('AS.ARC.fnFormPanel', {
			cls: 'as-page-panel',
			page: fn,
			region: 'west',
			width: 245,
			height: 500,
			bodyStyle: 'border:none;background:transparent;',
			style: 'background-image: url("' + fn.imageUrl + 'left_border.png");' 
				+ 'background-repeat: no-repeat;'
				+ 'border:none;'
		});

		return fn.westPanel;
	},
	//登入前的頁面
	getLoginPanel: function () {
		var fn = this;
		fn.loginPanel = Ext.create('Ext.container.Container', {
			cls: 'as-page-panel',
			height: 500,
			width: 845,
			border: false,
			items: [
				{
					xtype: 'displayfield',
					fieldStyle: {fontSize: '18px'},
					value: '<b>' + _S('ONEDRIVE', 'SIGN_IN') + '</b>'
				}, 
				{
					xtype: 'displayfield',
					value: '<hr width = 560 style = "border:1px height:2px color = #777777">'
				}, 
				{
					xtype: 'displayfield',
					value: '<b>' + _S('ONEDRIVE', 'CLICK_ICON') + '</b>'
				},
				{
					xtype: 'container',
					itemId: 'signin',
					width: 600,
					layout: {
						type: 'hbox'
					},
					items: [
						{
							xtype: 'button',
							margin: '0 5 0 0',
							itemId: 'signinaddress',
							text: _S('ONEDRIVE', 'SIGN_IN'),
							handler: function () {
								var url = fn.address + escape('&adm_url=' + window.location.protocol + '//' + window.location.host + '/');
								window.open(url, "newwindow", "height=480, width=480,toolbar=no,menubar=no, scrollbars=no, resizable=no, location=no, status=no");
							}
						}, 
						{
							xtype: 'image',
							itemId: 'loading',
							height: 24,
							width: 24,
							hidden: true,
							draggable: false,
							src: fn.imageUrl + 'loading.gif',
							scope: this
						}
					]

				}
			]
		});
		
		return fn.loginPanel;
	},
	//設定步驟頁面
	getSettingPanel: function() {
		var fn = this;
		
		var hasInvalid = function() {
            var root = fn.settingPanel.items.get('serverTreePanel').items.get('fs').items.get('servertree').getRootNode();
            var sizeLimit =  fn.settingPanel.items.get('filterPanel').items.get('size_limit');
			var uploadLimit = fn.settingPanel.items.get('configPanel').items.get('fs1').items.get('upload_limit');
			var downloadLimit = fn.settingPanel.items.get('configPanel').items.get('fs1').items.get('download_limit');
            //check serverTree is at last one checked folder
            if(!root.findChild('checked', true, true) || !sizeLimit.isValid() || !uploadLimit.isValid() || !downloadLimit.isValid()) {
                return true;
            }
        }
		
		var resetSettingPanel = function () {
			
			var filterPanel = fn.settingPanel.items.get('filterPanel');
			var filterSet = filterPanel.items.get('filterSet');
			var documentCt = filterSet.items.get('documentCt').items.get('ct2').query('checkbox');
			var videoCt = filterSet.items.get('videoCt').items.get('ct2').query('checkbox');
			var musicCt = filterSet.items.get('musicCt').items.get('ct2').query('checkbox');
			var photoCt = filterSet.items.get('photoCt').items.get('ct2').query('checkbox');
			var applicationCt = filterSet.items.get('applicationCt').items.get('ct2').query('checkbox');
			var customCt = filterSet.items.get('customCt').items.get('ct2');
			var path = fn.settingPanel.items.get('serverTreePanel').items.get('path-ct').items.get('path_df');
			var serverTree = fn.settingPanel.items.get('serverTreePanel').items.get('fs').items.get('servertree');
			var configPanel = fn.settingPanel.items.get('configPanel');
			var sizeLimit = filterPanel.items.get('size_limit');
			var uploadLimit = configPanel.items.get('fs1').items.get('upload_limit');
			var downloadLimit = configPanel.items.get('fs1').items.get('download_limit');
			var syncRG = configPanel.items.get('fs2').items.get('sync_rg');
			var enableUpload = configPanel.items.get('fs2').items.get('enable_upload');
			var deleteRemote = configPanel.items.get('fs2').items.get('delete_remote');
			var enableDownload = configPanel.items.get('fs2').items.get('enable_download');
			var deleteLocal = configPanel.items.get('fs2').items.get('delete_local');
			var root = serverTree.getStore().getProxy();
			
			AS.ARC.ajax({
                url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act: 'get_conf'}),
                method: 'post',
                success: function (json, opts) {
                    path.setValue(json.conf.local_root);
                },
                failure: function(json, opts) {
                }
            });
			
			
        	root.extraParams.id = '';
			root.extraParams.path = '';
            if(!serverTree.getStore().isLoading()) {
                serverTree.el.mask();
                serverTree.getStore().load();
                setTimeout(function() {
                    serverTree.el.mask(_S('COMMON', 'LOADING'));
                }, 100);
            }
			sizeLimit.setValue(0);
			uploadLimit.setValue(0);
			downloadLimit.setValue(0);
			syncRG.setValue({sync: 1});
			enableUpload.setValue(true);
			deleteRemote.setValue(true);
			enableDownload.setValue(true);
			deleteLocal.setValue(true);
			

			for (var i = 0; i < documentCt.length; i ++) {
				documentCt[i].setValue(false);
			}

			for (var i = 0; i < videoCt.length; i ++) {
				videoCt[i].setValue(false);
			}

			for (var i = 0; i < musicCt.length; i ++) {
				musicCt[i].setValue(false);
			}

			for (var i = 0; i < photoCt.length; i ++) {
				photoCt[i].setValue(false);
			}

			for (var i = 0; i < applicationCt.length; i ++) {
				applicationCt[i].setValue(false);
			}

			customCt.removeAll();
		}
		
		var navHandler = function(direction) {
			var prev = prevBtn;
			var next = nextBtn;
			
			var activeIndex = fn.settingPanel.items.indexOf(fn.settingPanel.getLayout().activeItem);
			
			if(activeIndex == 0) { 
				if(direction == 1) {
					fn.settingPanel.getLayout().setActiveItem(1);
					prev.enable();
				}
			}  else if(activeIndex == 1) { 
				
				if(direction == -1) {
					fn.settingPanel.getLayout().setActiveItem(0);
					prev.disable();
				} else {
					fn.settingPanel.getLayout().setActiveItem(2);
					next.setText(_S('COMMON', 'FINISH'));
					prev.enable();
					next.setDisabled(hasInvalid());
				}
			
			} else if(activeIndex == 2) {
				if(direction == -1) {
					
					fn.settingPanel.getLayout().setActiveItem(1);
					next.enable();
					next.setText(_S('COMMON', 'NEXT'));
					
				} else {
						//最後步驟 finish
						fn.win.el.mask(_S('COMMON','LOADING'));
						
						var filterPanel = fn.settingPanel.items.get('filterPanel');
						var filterSet = filterPanel.items.get('filterSet');
						
						var documentCt = filterSet.items.get('documentCt').items.get('ct2').query('checkbox');
						var videoCt = filterSet.items.get('videoCt').items.get('ct2').query('checkbox');
						var musicCt = filterSet.items.get('musicCt').items.get('ct2').query('checkbox');
						var photoCt = filterSet.items.get('photoCt').items.get('ct2').query('checkbox');
						var applicationCt = filterSet.items.get('applicationCt').items.get('ct2').query('checkbox');
						var customCt = filterSet.items.get('customCt').items.get('ct2').query('checkbox');
						var path = fn.settingPanel.items.get('serverTreePanel').items.get('path-ct').items.get('path_df').getValue();
						var physicalPath = '\/volume1' + path;
						var serverPath = [];
						var records = fn.settingPanel.items.get('serverTreePanel').items.get('fs').items.get('servertree');
						var filterExtName = [];
						var filterName = [];
						var userDefExtName = [];
						var configPanel = fn.settingPanel.items.get('configPanel');
						var sizeLimit = filterPanel.items.get('size_limit').getValue();
						var uploadLimit = configPanel.items.get('fs1').items.get('upload_limit').getValue();
						var downloadLimit = configPanel.items.get('fs1').items.get('download_limit').getValue();
						var enableUpload = configPanel.items.get('fs2').items.get('enable_upload').getValue();
						var deleteRemote = configPanel.items.get('fs2').items.get('delete_remote').getValue();
						var enableDownload = configPanel.items.get('fs2').items.get('enable_download').getValue();
						var deleteLocal = configPanel.items.get('fs2').items.get('delete_local').getValue();
					
						records.getRootNode().cascadeBy(function(n) {
							
							if(!n.data.root && !n.data.checked) {
								serverPath.push(n.data.path);
							}
							
						});
						
					
						for (var i = 0; i < documentCt.length; i ++) {
							if (documentCt[i].getValue() == true) {
								filterExtName.push(documentCt[i].boxLabel);
							}
						}
								
						for (var i = 0; i < videoCt.length; i ++) {
							if (videoCt[i].getValue() == true) {
								filterExtName.push(videoCt[i].boxLabel);
							}
						}
								
						for (var i = 0; i < musicCt.length; i ++) {
							if (musicCt[i].getValue() == true) {
								filterExtName.push(musicCt[i].boxLabel);
							}
						}
								
						for (var i = 0; i < photoCt.length; i ++) {
							if (photoCt[i].getValue() == true) {
								filterExtName.push(photoCt[i].boxLabel);
							}
						}
								
						for (var i = 0; i < applicationCt.length; i ++) {
							if (applicationCt[i].getValue() == true) {
								filterExtName.push(applicationCt[i].boxLabel);
							}
						}
						
						for (var i = 0; i <	customCt.length; i ++) {
							
							userDefExtName.push(customCt[i].boxLabel);
							
							if (customCt[i].getValue() == true) {
							
								filterExtName.push(customCt[i].boxLabel);
								
							}
						}
						
						
						
						var conf = {
							"local_root": path,
							"local_root_path": physicalPath,
							"size_limit": sizeLimit,
							"upload_limit": uploadLimit,
							"download_limit": downloadLimit,
							"upload": enableUpload,
							"download": enableDownload,
							"delete_remote": deleteRemote,
							"delete_local": deleteLocal,
							"filter_extname": filterExtName,
							//"filter_name": filterName,
							"user_def_extname": userDefExtName,
							"filter_path": serverPath
						};
						
						
						AS.ARC.ajax({
							url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act: 'set_conf', conf: JSON.stringify(conf)}),
							method: 'post',
							success: function (json, opts) {
								fn.win.el.unmask();
								fn.mainPanel.getLayout().setActiveItem(2);
								var location = fn.accountPanel.items.get('fs').items.get('locationData').items.get('location');
								location.setValue(path);
							},
							failure: function (json, opts) {
								fn.win.el.unmask();
							}
						});				
					
				
				}
			}
		}
		//上一頁
		var prevBtn = Ext.create('Ext.button.Button', {
			xtype: 'button',
			itemId: 'prev',
			text: _S('COMMON', 'PREVIOUS'),
			handler: Ext.bind(navHandler, fn, [-1]),
			disabled: true
		});
		//下一頁
		var nextBtn = Ext.create('Ext.button.Button', {
			xtype: 'button',
			itemId: 'next',
			text: _S('COMMON', 'NEXT'),
			handler: Ext.bind(navHandler, fn, [1])
			
		});
		
		var applyValidator = function() {
            var root = fn.settingPanel.items.get('serverTreePanel').items.get('fs').items.get('servertree').getRootNode();
			var activeIndex = fn.settingPanel.items.indexOf(fn.settingPanel.getLayout().activeItem);
            var sizeLimit =  fn.settingPanel.items.get('filterPanel').items.get('size_limit');
			var uploadLimit = fn.settingPanel.items.get('configPanel').items.get('fs1').items.get('upload_limit');
			var downloadLimit = fn.settingPanel.items.get('configPanel').items.get('fs1').items.get('download_limit');
			
            if(root.findChild('checked', true, true) && sizeLimit.isValid() && uploadLimit.isValid() && downloadLimit.isValid()) {
                if (activeIndex === 2) {
					nextBtn.enable();
				}
            } else {
				if (activeIndex === 2) {
                	nextBtn.disable();
				}
            }
        }
		
		var filterPanel = fn.getFilterPanel();
		var configPanel = fn.getConfigPanel();
		var uploadLimit = configPanel.items.get('fs1').items.get('upload_limit');
		var downloadLimit = configPanel.items.get('fs1').items.get('download_limit');
		
		uploadLimit.on('validitychange', applyValidator);
		downloadLimit.on('validitychange', applyValidator);
		
		var getFileBrowse = function() {
			var savePath = Ext.create('Ext.form.field.Text', {
				itemId: 'path_df',
				dirtyPath: false,
				width: 450,
				//labelWidth: AS.ARC.config.layout.defaultLabelWidth,
				//fieldLabel: _S('GOOGLE_DRIVE', 'SYNC_FOLDER'),
				value: '',
				readOnly: true,
				allowBlank: false,
				blankText: _S('MESSAGE', 'HF00011'),
				listeners: {
                    afterrender: function(df) {
                        df.validate();
                        AS.ARC.ajax({
                            url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act: 'get_conf'}),
                            method: 'post',
                            success: function (json, opts) {
                                df.setValue(json.conf.local_root);
                            },
                            failure: function(json, opts) {
                            }
                        });
                    }
                }
			});

			var browseBtn = Ext.create(Ext.button.Button, {
				itemId: 'browse',
				margin: '0 0 0 10',
				text: _S('COMMON', 'BROWSE'),
				handler: function () {
					var fs = Ext.create('AS.ARC.treeSelector', {
						hideReadOnly: true,
						parentWin: fn.win,
						objectPath: savePath,
						isShowHome: true,

					});
					fs.win.show();
				}
			});


			var ct = Ext.create(Ext.form.FieldSet, {
				itemId: 'path-ct',
				title: _S('ONEDRIVE', 'PLEASE_SELECT_LOCAL_FOLDER'),
				layout: 'hbox',
				padding: '10 15 10 15',
				items: [
					savePath,
					browseBtn
				]
			});

			return ct;
		
		};
		
		
		// OneDrive 資料夾
		var serverTreePanel = Ext.create(Ext.panel.Panel, {
			itemId: 'serverTreePanel',
			//width: 600,
			height: 360,
			border: false,
			items: [
				getFileBrowse(),
				{
					xtype: 'fieldset',
					itemId: 'fs',
					title: _S('ONEDRIVE', 'DO_NOT_SYNC_FOLDER'),
					border: false,
					height: 300,
					items: [
						fn.getServerTree()
					]
				},
				{
					xtype: 'displayfield',
					itemId: 'path',
					hidden: true
				}
			]
		});
		
		fn.settingPanel = Ext.create('Ext.panel.Panel', {
            height: 420,
            activeItem: 0,
            layout: 'card',
            items: [
                serverTreePanel,
                filterPanel,
                configPanel
            ],
            fbar: [
                prevBtn,
                nextBtn
            ],
            loadData: function() {
				resetSettingPanel();
                fn.settingPanel.getLayout().setActiveItem(0);
                prevBtn.disable();
                nextBtn.enable();
                nextBtn.setText(_S('COMMON', 'NEXT'));
            },
        });
		
		return {
			xtype: 'container',
			width: 600,
			height: 500,
			items: [
				{
					xtype: 'image',
					height: 24,
					width: 24,
					margin: '2 0 5 550',
					draggable: false,
					hidden: true,
					src: fn.imageUrl + 'disconnect_nomal.png',
					style: {
						cursor: 'pointer'
					},
					scope: this,
					listeners: {
						render: function (img, eOpts) {
							img.el.dom.title = _S('ONEDRIVE', 'UNLINK');
							Ext.fly(this.el).on('click', function(e, t) {
								img.setSrc(fn.imageUrl + 'disconnect_press.png');
								fn.doLogout();
							});
							Ext.fly(this.el).on('mouseover', function(e, t) {
								img.setSrc(fn.imageUrl + 'disconnect_over.png');
							});
							Ext.fly(this.el).on('mouseout', function(e, t) {
								img.setSrc(fn.imageUrl + 'disconnect_nomal.png');
							});
						}
					}
				},
				fn.settingPanel
			
			]
		
		}
	},
	
	
	//登入後的頁面
	getAccountPanel: function () {
		var fn = this;
		
		var capacityBar = Ext.create(Ext.ProgressBar, {
			itemId: 'capacityBar',
			width: 500,
			style: 'position: absolute; top: 330px;',
			cls: 'progressbar-size'
		});
		
		var sizeBar = Ext.create(Ext.container.Container, {
			itemId: 'size-bar',
			layout: 'hbox',
			style: 'position: absolute; top: 350px; left: 100px;',
			height: 30,
			items: [
			{
				xtype: 'displayfield',								
				value: '<img src="' + AS.ARC.util.fixDc('apps/storageManager/images/space_used.png') + '" style="height:18px;width:16px;border:1px solid #888; margin-top: 5px;" />'
			}, 
			{
				xtype: 'displayfield',
				itemId: 'used',
				width: 180,
				style: 'margin-left: 20px; margin-top: 5px;'
			}, 
			{
				xtype: 'displayfield',								
				value: '<img src="' + AS.ARC.util.fixDc('apps/storageManager/images/space_free.png') + '" style="height:18px;width:16px;border:1px solid #888; margin-top: 5px;" />'
			}, 
			{
				xtype: 'displayfield',
				itemId: 'free',
				width: 180,
				style: 'margin-left: 20px; margin-top: 5px;'
			}]
		});
		
		fn.accountPanel = Ext.create('Ext.container.Container', {
			cls: 'as-page-panel',
			height: 500,
			width: 845,
			border: false,
			defaults: {
				labelWidth: AS.ARC.config.layout.labelWidthSmall,
				width: 600
			},
			items: [
				{
					xtype: 'container',
					width: 560,
					height: 30,
					itemId: 'title',
					layout: {
						type: 'hbox'
					},
					items: [
						{
							xtype: 'button',
							itemId: 'start',
							text: _S('ONEDRIVE', 'START'),
							minWidth: 75,
							height: 25,
							hidden: true,
							handler: function () {
								
								fn.win.el.mask(_S('COMMON', 'APPLYING'));
								
								//handle enable
								AS.ARC.ajax({
									url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act: 'enable'}),
									method: 'post',
									success: function () {
										fn.accountPanel.items.get('title').items.get('start').hide();
										fn.accountPanel.items.get('title').items.get('stop').show();
										fn.win.el.unmask();
									},
									failure: function (json, opts) {
										AS.ARC.util.showMsgWindow({
											5022: _S('ONEDRIVE', 'FILE_IS_BUSY'),
											5026: _S('ONEDRIVE', 'FILE_SYSTEM_READ_ONLY'),
											//5028: _S('ONEDRIVE', 'USER_NOT_LOGIN'),
											5401: _S('ONEDRIVE', 'UNKNOW_ERROR'),
											5402: _S('ONEDRIVE', 'OUT_OF_MEMORY'),
										}, json, fn.win);
										fn.win.el.unmask();
									}
								});	
							}
						}, 
						{
							xtype: 'button',
							itemId: 'stop',
							minWidth: 75,
							maxWidth: 150,
							height: 25,
							hidden: true,
							text: _S('ONEDRIVE', 'STOP'),
							handler: function () {
								
								fn.win.el.mask(_S('COMMON', 'APPLYING'));
								
								// handle disable
								AS.ARC.ajax({
									url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act: 'disable'}),
									method: 'post',
									success: function () {
										fn.accountPanel.items.get('title').items.get('start').show();
										fn.accountPanel.items.get('title').items.get('stop').hide();
										fn.win.el.unmask();
									},
									failure: function (json, opts) {
										
										AS.ARC.util.showMsgWindow({
											5022: _S('ONEDRIVE', 'FILE_IS_BUSY'),
											5026: _S('ONEDRIVE', 'FILE_SYSTEM_READ_ONLY'),
											5401: _S('ONEDRIVE', 'UNKNOW_ERROR'),
											5402: _S('ONEDRIVE', 'OUT_OF_MEMORY'),
										}, json, fn.win);
										
										fn.win.el.unmask();
									}
								});	
							}
						},
						{
							xtype: 'button',
							itemId: 'settingPanelBtn',
							text: _S('COMMON', 'SETTINGS'),
							//minWidth: 75,
							handler: function() {
								//fn.settingTabPanel.show();
								fn.getSettingTabPanel();
								fn.win.el.mask();

							}
						},
						{
							xtype: 'tbfill'
						},
						{
							xtype: 'image',
							height: 24,
							width: 24,
							margin: '2 0 0 0',
							draggable: false,
							src: fn.imageUrl + 'disconnect_nomal.png',
							style: {
								cursor: 'pointer'
							},
							scope: this,
							listeners: {
								render: function (img, eOpts) {
									img.el.dom.title = _S('ONEDRIVE', 'UNLINK');
									Ext.fly(this.el).on('click', function(e, t) {
										img.setSrc(fn.imageUrl + 'disconnect_press.png');
										fn.doLogout();
									});
									Ext.fly(this.el).on('mouseover', function(e, t) {
										img.setSrc(fn.imageUrl + 'disconnect_over.png');
									});
									Ext.fly(this.el).on('mouseout', function(e, t) {
										img.setSrc(fn.imageUrl + 'disconnect_nomal.png');
									});
								}
							}
						}
					]
				},
				{
					xtype: 'fieldset',
					itemId: 'fs',
					title: _S('ONEDRIVE', 'ACCOUNT_INFORMATION'),
					width: 575,
					height: 350,
					style: 'margin-top: 10px;',
					defaults: {
						width: 600
					},
					items: [
						{
							xtype: 'displayfield',
							fieldLabel: _S('ONEDRIVE', 'NAME'),
							labelWidth: AS.ARC.config.layout.labelWidthSmall + 10,
							itemId: 'name',
							value: '--'
						}, 
						{
							xtype: 'displayfield',
							fieldLabel: _S('ONEDRIVE', 'LINK'),
							labelWidth: AS.ARC.config.layout.labelWidthSmall + 10,
							itemId: 'link',
							value: '--',
						},
						{
							xtype: 'displayfield',
							fieldLabel: _S('ONEDRIVE', 'STATUS'),
							labelWidth: AS.ARC.config.layout.labelWidthSmall + 10,
							itemId: 'status',
							value: '--'
						}, 
						{
							xtype: 'container',
							margin: '15 0 0 0',
							itemId: 'locationData',
							width: 600,
							layout: 'hbox',
							style: 'padding-top:3px',
							height: 45,
							items: [
								{
									xtype: 'textfield',
									itemId: 'location',
									width: 350,
									readOnly: true,
									labelWidth: AS.ARC.config.layout.labelWidthSmall + 10,
									fieldLabel: _S('ONEDRIVE', 'LOCATION'),
									listeners: {
										afterrender: function(df) {
											
											AS.ARC.ajax({
												url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act: 'get_conf'}),
												method: 'post',
												success: function (json, opts) {
													df.setValue(json.conf.local_root);
												},
												failure: function(json, opts) {

												}


											});
										
										}
									}
								}, {
									xtype: 'button',
									margin: '0 0 0 5',
									minWidth: 75,
									text: _S('NETWORK','OPEN'),
									handler: function(btn) {

										AS.ARC.ajax({
											url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act: 'get_conf'}),
											method: 'post',
											success: function (json, opts) {
												AS.ARC.core.openApp('app-fileExplorer', json.conf.local_root);
											},
											failure: function(json, opts) {

											}


										});
									}
								}
							]
						},
						{
							xtype: 'displayfield',
							fieldLabel: _S('ONEDRIVE', 'QUOTA'),
							labelWidth: AS.ARC.config.layout.labelWidthSmall + 10,
							itemId: 'quota',
							value: '--'
						},
						capacityBar,
						sizeBar
					]
				}
				
				

			],
			loadData: function () {
				fn.win.el.mask(_S('COMMON','LOADING'));
				fn.win.el.unmask();
			}
		});

		return fn.accountPanel;
	},
	//獲得使用者資訊
	getUserInfo: function () {
		var fn = this;

		AS.ARC.ajax({
			url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act: 'userinfo'}),
			method: 'post',
			success: function (json, opts) {
				
				var quotaGB = AS.ARC.util.convertSizeUnit(json.userinfo.quota);
				var availableGB = AS.ARC.util.convertSizeUnit(json.userinfo.available);
				var usedGB = AS.ARC.util.convertSizeUnit(json.userinfo.quota - json.userinfo.available);
				var	progValue = (json.userinfo.quota - json.userinfo.available) / json.userinfo.quota;
				var progText = '';
				var capacityBar = fn.accountPanel.items.get('fs').items.get('capacityBar');
				var sizeBar = fn.accountPanel.items.get('fs').items.get('size-bar');
				
				if (progValue) {
					progText = (progValue * 100).toFixed(2) + '%';
				} else {
					progText = '0 %';
				}
				
				capacityBar.updateProgress(progValue, progText);
				sizeBar.items.get('used').setValue(_S('COMMON', 'USED') + ' ' + usedGB);
				sizeBar.items.get('free').setValue(_S('COMMON', 'FREE') + ' ' + availableGB);
				fn.accountPanel.items.get('fs').items.get('name').setValue(json.userinfo['name']);
				fn.accountPanel.items.get('fs').items.get('link').setValue('<a href="' + json.userinfo.link + '" target="_blank">' + 'https://onedrive.live.com/' + '</a>');
				fn.accountPanel.items.get('fs').items.get('quota').setValue(quotaGB);

				fn.userInfo = setTimeout(function() {
					fn.getUserInfo();
				}, 5000);
			},
			failure: function (json, opts) {
				fn.userInfo = setTimeout(function () {
					fn.getUserInfo();
				}, 5000);
			}
		});
	},
	//執行登出動作
	doLogout: function () {
		var fn = this;
		
		AS.ARC.ajax({
			url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act: 'logout'}),
			method: 'post',
			success: function (json, opts) {
				//fn.accountPanel.items.get('emailLink').items.get('email').setValue('');
				fn.connCounter.clear();
				
		
				fn.mainPanel.getLayout().setActiveItem(0);
				fn.mainPanel.items.items[0].items.get('signin').items.get('loading').hide();
				clearTimeout(fn.userInfo);
				clearTimeout(fn.status);

				fn.checkLogin(true);
			},
			failure: function (json, opts) {
				/*AS.ARC.util.showMsgWindow({
			        5022: _S('ONEDRIVE', 'FILE_IS_BUSY'),
			        5026: _S('ONEDRIVE', 'FILE_SYSTEM_READ_ONLY'),
			        5401: _S('ONEDRIVE', 'UNKNOW_ERROR'),
			        5402: _S('ONEDRIVE', 'OUT_OF_MEMORY'),
			    }, json, fn.win);*/
			}
		});
	},
	//執行登入動作
	doLogin: function () {
		var fn = this;
		
		AS.ARC.ajax({
			url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act: 'login'}),
			method: 'post',
			params: {
				code: fn.mainPanel.items.items[0].items.get('loginContainer').items.get('code').getValue()
			},
			success: function (json, opts) {
				
			},
			failure: function (json, opts) {
				AS.ARC.util.showMsgWindow({
			        5022: _S('ONEDRIVE', 'FILE_IS_BUSY'),
			        5026: _S('ONEDRIVE', 'FILE_SYSTEM_READ_ONLY'),
			        //5028: _S('ONEDRIVE', 'USER_NOT_LOGIN'),
			        5401: _S('ONEDRIVE', 'UNKNOW_ERROR'),
			        5402: _S('ONEDRIVE', 'OUT_OF_MEMORY'),
			        5501: _S('ONEDRIVE', 'AUTHENTICATION_CODE_ERROR')
			    }, json, fn.win);
			}

		});
	},
	//檢查是否登入
	checkLogin: function (tryLogin) {
		var fn = this;
		
		AS.ARC.ajax({
			url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act: 'check_login'}),
			method: 'post',
			success: function (json, opts) {
				if(!json.login){
					if (tryLogin) {
						fn.address = json.url;
						fn.win.el.unmask();
						fn.loginID = setTimeout(function () {
							fn.checkLogin(true);
						}, 3000);
					} else {
						fn.doLogout();
					}
				} else {
					if (tryLogin) {
						AS.ARC.ajax({
							url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act: 'check_set'}),
							method: 'post',
							success: function(json, opts) {
								if (!json.settle) {
                                    //go to SettingPanel
                                    fn.settingPanel.loadData();
                                    fn.mainPanel.getLayout().setActiveItem(1);
                                    fn.win.el.unmask();
                                } else {
                                    //go to AccountPanel
                                    fn.accountPanel.loadData();
                                    fn.mainPanel.getLayout().setActiveItem(2);
                                }
							},
							failure: function(json, opts) {

							}
						});
						
						fn.win.el.unmask();
						fn.userInfo = setTimeout(function() {
							fn.getUserInfo();
						}, 3000);

						fn.status = setTimeout(function() {
							fn.getStatus();
						}, 3000);
					}
				}
			},
			failure: function (json, opts) {
                AS.ARC.util.showMsgWindow({
			        5022: _S('ONEDRIVE', 'FILE_IS_BUSY'),
			        5402: _S('ONEDRIVE', 'OUT_OF_MEMORY'),
			    }, json, fn.win);
            }
		});
	},
	//OneDrive 資料夾(TreePanel)
	getServerTree: function (applyBtn) {
		var fn = this;
		var serverTreeStore = Ext.create('Ext.data.TreeStore', {
			proxy: {
				type: 'ajax',
				url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act: 'list_dir'}),
				reader: {
					type: 'json',
					root: 'children'
				},
				extraParams:{  
                	id: '',
					path: ''
            	}
			},
			fields: [
				{name: 'text'},
				{name: 'path'},
				{name: 'dirLoaded'}
			]
			
		});
		
		
		var tree = new Ext.tree.TreePanel({
			//width: 500,
			height: 250,
			style: 'border: none;',
			itemId: 'servertree',
			rootVisible: false,
			useArrows : true,
			autoScroll: true,
			border: false,
			resizable: false,
			store: serverTreeStore,
			displayField: 'text',
			animate: false,
			listeners : {
				 checkchange: function(node, checked, options) {
                    //子節點打勾 所有父節點也都要打勾
                    if(checked) {
                        node.bubble(function(n) {
                            n.set('checked', checked);
                        });
                    }
                    //子節點若還沒載入 則只做展開的動作 處理交給beforeitemexpand和itemexpand
                    if(!node.isLoaded()) {
                        node.expand();
                    } else {
                        node.expand(false, function() {
                            node.cascadeBy(function(n) {
                                n.set('checked', checked);
                                n.set('cls', '');
                            });
                        });
                    }
                    //處理半勾狀態
                    //子節點有一個以上沒打勾 所有父節點都要是半勾狀態
                    node.set('cls', '');
                    var parent = node.parentNode;
                    if(parent) {
                        var halfStatus = false;
                        parent.bubble(function(n) {
                            if(!halfStatus) {
                                n.eachChild(function(child) {
                                    if(!child.data.checked || child.data.cls === 'x-tree-checked-down') {
                                        return (halfStatus = true);
                                    }
                                });
                            }
                            if(halfStatus) {
                                n.set('cls', 'x-tree-checked-down');
                            } else {
                                n.set('cls', '');
                            }
                        });
                    }
                },
                beforeitemexpand: function(node) {
                    if(!node.isLoaded()) {
                        var root = tree.getStore().getProxy();
                        root.extraParams.id = node.data.id;
                        root.extraParams.path = node.data.path;
                    } else {
                        node.data.dirLoaded = true;
                    }
                },
                itemexpand: function(node) {
                    if(!node.data.dirLoaded) {
                        node.data.dirLoaded = true;
                        node.cascadeBy(function(n){
                            n.data.checked = node.data.checked;
                        });
                    }
                },
                afterlayout: function() {
                    if(tree.store.isLoading()) {
                        tree.el.mask(_S('COMMON', 'LOADING'));
                    }
                },
                load: function() {
                    if(applyBtn) {
                        applyBtn.enable();
                    }
                    tree.el.unmask();
                }

			}
			
		}); 
		
		return tree;
		
		
	},
	
	//取得檔案過濾器面板
	getFilterPanel: function() {
		
		var fn = this;
		
		var filterSet = Ext.create('AS.ARC.onedrive.FilterSet');
		
		var filterPanel = Ext.create(Ext.panel.Panel, {
			itemId: 'filterPanel',
			height: 450,
			border: false,
			items: [
				{
					xtype: 'displayfield',
					margin: '5 0 0 0',
					width: 533,
					value: _S('ONEDRIVE', 'FILTER_TEXT')
				},
				{
					xtype: 'numberfield',
					itemId: 'size_limit',
					style: 'margin-top: 10px;',
					labelWidth: 200,
					fieldLabel: _S('ONEDRIVE', 'SIZE_LIMIT'),
					minValue: 0,
					allowBlank: false,
					blankText: _S('MESSAGE', 'HF00011'),
					maxValue: 10239,
					allowDecimals: false,
					msgTarget: AS.ARC.config.msgTarget,
					value: 0
				}, 
				filterSet,
				{
					xtype: 'container',
					height: 40,
					layout: 'column',
					items: [
						{
							xtype: 'textfield',
							id: 'onedrive_tooltip',
							itemId: 'tf',
							columnWidth: .8,
							height: 25,
							maxLength: 32,
							maxLengthText: Ext.String.format(_S('MESSAGE', 'HF00016'), '32'),
							emptyText: _S('ONEDRIVE', 'FILE_OR_FILE_EXT'),
							listeners: {
								change: function(tf, newValue) {
									if (newValue.length > 32) {
										tf.next().disable();
									} else {
										tf.next().enable();
									}
								},
								render: function(tf) {
									tf.el.dom.setAttribute('data-qtip', '1. ' + _S('ONEDRIVE', 'FILTER_RULES_1') + '<br/>' +
														  				'2. ' + _S('ONEDRIVE', 'FILTER_RULES_2') + '<br/>' +
														   				'3. ' + _S('ONEDRIVE', 'FILTER_RULES_3') + '<br/>' +
														   				'4. ' + _S('ONEDRIVE', 'FILTER_RULES_4') + '<br/>' +
														   				'5. ' + _S('ONEDRIVE', 'FILTER_RULES_5') + '<br/>'
														  );
									
								}
							}
							
						}, 
						{
							xtype: 'button',
							itemId: 'add',
							style: 'margin-left: 5px;',
							//minWidth: 75,
							columnWidth: .2,
							text: _S('COMMON', 'ADD'),
							handler: function(btn) {
									
								var text = '';
								var documentCt = filterSet.items.get('documentCt').items.get('ct2').query('checkbox');
								var videoCt = filterSet.items.get('videoCt').items.get('ct2').query('checkbox');
								var musicCt = filterSet.items.get('musicCt').items.get('ct2').query('checkbox');
								var photoCt = filterSet.items.get('photoCt').items.get('ct2').query('checkbox');
								var applicationCt = filterSet.items.get('applicationCt').items.get('ct2').query('checkbox');
								var customCt = filterSet.items.get('customCt').items.get('ct2').query('checkbox');
								
								var textfield = btn.ownerCt.items.get('tf');
								var ary = [];
								var filterTextAry = [];
								
								for (var i = 0; i < documentCt.length; i ++) {
									ary.push(documentCt[i].boxLabel);
								}
								
								for (var i = 0; i < videoCt.length; i ++) {
									ary.push(videoCt[i].boxLabel);
								}
								
								for (var i = 0; i < musicCt.length; i ++) {
									ary.push(musicCt[i].boxLabel);
								}
								
								for (var i = 0; i < photoCt.length; i ++) {
									ary.push(photoCt[i].boxLabel);
								}
								
								for (var i = 0; i < applicationCt.length; i ++) {
									ary.push(applicationCt[i].boxLabel);
								}
								
								for (var i = 0; i <	customCt.length; i ++) {
									ary.push(customCt[i].boxLabel);
								}
								
								filterTextAry = textfield.getValue().split(',');
								
								for (var i = 0; i < filterTextAry.length; i ++) {
									
									if (filterTextAry[i][0] == '.') {
										text = filterTextAry[i].toLowerCase();
									} else {
										text = filterTextAry[i];
									}


									if (text != '' && ary.indexOf(text) == -1) {

										filterSet.items.get('customCt').items.get('ct2').add(
											{
												xtype: 'container',
												layout: 'hbox',
												width: 430,
												items: [

													{
														xtype: 'checkbox',
														checked: true,
														style: '',
														boxLabel: text,
														handler: function(checkbox, checked) {

															var selectAllCb = checkbox.ownerCt.ownerCt.ownerCt.items.get('ct1').items.get('select_all');
                                                            var checkAllTrue = true;
                                                            var checkCount = 0;
                                                            selectAllCb.removeCls('gray-checkbox');
                                                            for (var i = 0; i < checkbox.ownerCt.ownerCt.query('checkbox').length; i ++) {
                                                                if (!checkbox.ownerCt.ownerCt.query('checkbox')[i].getValue()) {
                                                                    checkAllTrue = false;
                                                                } else {
                                                                    checkCount += 1;
                                                                }
                                                            }
                                                            if (checkAllTrue == true) {
                                                                selectAllCb.setValue(true);
                                                            } else {
                                                                if(checkCount) {
                                                                    selectAllCb.addCls('gray-checkbox');
                                                                }
                                                                selectAllCb.setRawValue(false);
                                                                selectAllCb.lastValue = false;
                                                            }
														}
													},
													{
														xtype: 'tbfill'
													},
													{
														xtype: 'image',
														width: 17,
														height: 17,
														style: 'cursor: pointer;',
																src: fn.imageUrl + 'close.png',
														listeners: {
															render: function(img) {
																img.getEl().on('click', function() {
																	filterSet.items.get('customCt').items.get('ct2').remove(img.ownerCt, true);
																});
															}
														}
													}
												]
											}
										);	

										filterSet.items.get('customCt').items.get('ct2').show();

									} else {
										Ext.create('Ext.tip.ToolTip', {
											hideDelay : 3000,
											padding: '0 0 0 0',
											maxWidth:400,
											html: _S('ERROR', 'NEW_FILE_NAME_EXISTED'),
											dismissDelay: 5000
										}).showAt([textfield.getEl().getX(), textfield.getEl().getY() + 25]);
										
									}
									
									
									
								}
								textfield.setValue('');
								
							}
						}
					]
				}
			]
		});
		
		return filterPanel;
	},
	//取得一般設定面板
	getConfigPanel: function() {
		var configPanel = Ext.create(Ext.panel.Panel, {
			itemId: 'configPanel',
			height: 400,
			border: false,
			layout: 'anchor',
			items: [
				{
					xtype: 'fieldset',
					itemId: 'fs1',
					title: _S('ONEDRIVE', 'TRAFFIC_CONTROL'),
					height: 100,
					items: [
						{
							xtype: 'numberfield',
							itemId: 'upload_limit',
							labelWidth: 350,
							fieldLabel: _S('ONEDRIVE', 'UPLOAD_LIMIT'),
							minValue: 0,
							value: 0,
							allowBlank: false,
							blankText: _S('MESSAGE', 'HF00011'),
							maxValue: 999999,
							msgTarget: AS.ARC.config.msgTarget,
							allowDecimals: false
							
						}, 
						{
							xtype: 'numberfield',
							itemId: 'download_limit',
							labelWidth: 350,
							fieldLabel: _S('ONEDRIVE', 'DOWNLOAD_LIMIT'),
							minValue: 0,
							value: 0,
							allowBlank: false,
							blankText: _S('MESSAGE', 'HF00011'),
							maxValue: 999999,
							msgTarget: AS.ARC.config.msgTarget,
							allowDecimals: false
						}
					]
					
				}, 
				{
					xtype: 'fieldset',
					itemId: 'fs2',
					title: _S('COMMON', 'SYNCHRONIZATION_SETTINGS'),
					height: 140,
					items: [
						{
							xtype: 'radiogroup',
							itemId: 'sync_rg',
							columns: 1,
							items: [
								{
									xtype: 'radio',
									boxLabel: _S('ONEDRIVE', 'SYNCHRONIZITION'),
									name: 'sync',
									inputValue: 1,
									checked: true
								},
								{
									xtype: 'radio',
									boxLabel: _S('ONEDRIVE', 'ONEDRIVE_TO_NAS'),
									name: 'sync',
									inputValue: 2,
								},
								{
									xtype: 'radio',
									boxLabel: _S('ONEDRIVE', 'NAS_TO_ONEDRIVE'),
									name: 'sync',
									inputValue: 3,
								}
							],
							listeners: {
								change: function(radiogroup, newValue) {
									
									switch (newValue['sync']) {
										case 1:
											configPanel.items.get('fs2').items.get('enable_download').setValue(true);
											configPanel.items.get('fs2').items.get('delete_remote').hide();
											configPanel.items.get('fs2').items.get('delete_remote').setValue(true);
											configPanel.items.get('fs2').items.get('enable_upload').setValue(true);
											configPanel.items.get('fs2').items.get('delete_local').hide();
											configPanel.items.get('fs2').items.get('delete_local').setValue(true);
											
											break;
										case 2:
											configPanel.items.get('fs2').items.get('enable_download').setValue(true);		
											configPanel.items.get('fs2').items.get('delete_local').show();
											configPanel.items.get('fs2').items.get('enable_upload').setValue(false);
											configPanel.items.get('fs2').items.get('delete_remote').hide();
											break;
										case 3:
											configPanel.items.get('fs2').items.get('enable_upload').setValue(true);
											configPanel.items.get('fs2').items.get('delete_remote').show();
											configPanel.items.get('fs2').items.get('enable_download').setValue(false);
											configPanel.items.get('fs2').items.get('delete_local').hide();
											break;
											
									}
								},
								afterrender: function(radiogroup) {
									if (radiogroup.getValue().sync == 1) {
										configPanel.items.get('fs2').items.get('enable_download').setValue(true);
										configPanel.items.get('fs2').items.get('delete_remote').setValue(true);
										configPanel.items.get('fs2').items.get('enable_upload').setValue(true);
										configPanel.items.get('fs2').items.get('delete_local').setValue(true);
									}
									//console.log(radiogroup.sync.);
								}
							}
						},
						{
							xtype: 'checkbox',
							itemId: 'enable_upload',
							boxLabel: _S('ONEDRIVE', 'ENABLE_UPLOAD'),
							hidden: true,
							handler: function(checkbox, checked) {
								if (checked) {
									configPanel.items.get('fs2').items.get('delete_remote').enable();
								} else {
									configPanel.items.get('fs2').items.get('delete_remote').disable();
								}
							}
						}, 
						{
							xtype: 'checkbox',
							itemId: 'delete_remote',
							hidden: true,
							style: 'margin-left: 20px',
							boxLabel: _S('ONEDRIVE', 'KEEP_EXTRA')
						}, 
						{
							xtype: 'checkbox',
							itemId: 'enable_download',
							hidden: true,
							boxLabel: _S('ONEDRIVE', 'ENABLE_DOWNLOAD'),
							handler: function(checkbox, checked) {
								if (checked) {
									configPanel.items.get('fs2').items.get('delete_local').enable();
								} else {
									configPanel.items.get('fs2').items.get('delete_local').disable();
								}
							}
						}, 
						{
							xtype: 'checkbox',
							itemId: 'delete_local',
							hidden: true,
							style: 'margin-left: 20px',
							boxLabel: _S('ONEDRIVE', 'KEEP_EXTRA')
						}
					]
				},
				{
					xtype: 'displayfield',
					fieldStyle: {
						'color': 'red'
					},
					width: 542,
					value: _S('ONEDRIVE', 'ONEDRIVE_LIMIT_TEXT')
				},
				{
					xtype: 'displayfield',
					fieldStyle: {
						'color': 'red'
					},
					width: 542,
					value: _S('ONEDRIVE', 'ONEDRIVE_LIMIT_RULE1') + ' ' +_S('ONEDRIVE', 'ONEDRIVE_LIMIT_RULE2')
				}/*,
				{
					xtype: 'displayfield',
					fieldStyle: {
						'color': 'red'
					},
					width: 542,
					value: _S('ONEDRIVE', 'ONEDRIVE_LIMIT_RULE2')
				},*/
				
				
			]
		});
		
		return configPanel;
	},
	
	
	
	getSettingTabPanel: function() {
		var fn = this;
		
		var applyValidator = function() {
            var root = settingTabPanel.items.get('settingTabPanel').items.get('serverTreeTab').items.get('fs').items.get('servertree').getRootNode();
            if(root.findChild('checked', true, true) && sizeLimit.isValid() && uploadLimit.isValid() && downloadLimit.isValid()) {
                applyBtn.enable();
            } else {
                applyBtn.disable();
            }
        }
		
		var applyBtn = Ext.create('Ext.button.Button', {
			itemId: 'Apply',
			text: _S('COMMON', 'APPLY'),
			disabled: false,
			handler: function(btn) {
				settingTabPanel.el.mask(_S('COMMON', 'APPLYING'));
				fn.win.el.unmask();
				btn.disable();

				var filterPanel = settingTabPanel.items.get('settingTabPanel').items.get('filterTab').items.get('filterPanel');
				var filterSet = filterPanel.items.get('filterSet');
				var documentCt = filterSet.items.get('documentCt').items.get('ct2').query('checkbox');
				var videoCt = filterSet.items.get('videoCt').items.get('ct2').query('checkbox');
				var musicCt = filterSet.items.get('musicCt').items.get('ct2').query('checkbox');
				var photoCt = filterSet.items.get('photoCt').items.get('ct2').query('checkbox');
				var applicationCt = filterSet.items.get('applicationCt').items.get('ct2').query('checkbox');
				var customCt = filterSet.items.get('customCt').items.get('ct2').query('checkbox');
				var location = fn.accountPanel.items.get('fs').items.get('locationData').items.get('location');
				var path = settingTabPanel.items.get('settingTabPanel').items.get('serverTreeTab').items.get('path-ct').items.get('path_df').getValue();
				var physicalPath = '\/volume1' + path;
				var serverPath = [];
				var records = settingTabPanel.items.get('settingTabPanel').items.get('serverTreeTab').items.get('fs').items.get('servertree');
				var filterExtName = [];
				var filterName = [];
				var userDefExtName = [];
				var configPanel = settingTabPanel.items.get('settingTabPanel').items.get('configTab').items.get('configPanel');
				var sizeLimit = filterPanel.items.get('size_limit').getValue();
				var uploadLimit = configPanel.items.get('fs1').items.get('upload_limit').getValue();
				var downloadLimit = configPanel.items.get('fs1').items.get('download_limit').getValue();
				var enableUpload = configPanel.items.get('fs2').items.get('enable_upload').getValue();
				var deleteRemote = configPanel.items.get('fs2').items.get('delete_remote').getValue();
				var enableDownload = configPanel.items.get('fs2').items.get('enable_download').getValue();
				var deleteLocal = configPanel.items.get('fs2').items.get('delete_local').getValue();


				records.getRootNode().cascadeBy(function(n) {

					if(!n.data.root && !n.data.checked) {
						serverPath.push(n.data.path);
					}

				});


				for (var i = 0; i < documentCt.length; i ++) {
					if (documentCt[i].getValue() == true) {
						filterExtName.push(documentCt[i].boxLabel);
					}
				}

				for (var i = 0; i < videoCt.length; i ++) {
					if (videoCt[i].getValue() == true) {
						filterExtName.push(videoCt[i].boxLabel);
					}
				}

				for (var i = 0; i < musicCt.length; i ++) {
					if (musicCt[i].getValue() == true) {
						filterExtName.push(musicCt[i].boxLabel);
					}
				}

				for (var i = 0; i < photoCt.length; i ++) {
					if (photoCt[i].getValue() == true) {
						filterExtName.push(photoCt[i].boxLabel);
					}
				}

				for (var i = 0; i < applicationCt.length; i ++) {
					if (applicationCt[i].getValue() == true) {
						filterExtName.push(applicationCt[i].boxLabel);
					}
				}

				for (var i = 0; i <	customCt.length; i ++) {

					userDefExtName.push(customCt[i].boxLabel);

					if (customCt[i].getValue() == true) {
						filterExtName.push(customCt[i].boxLabel);
					}
				}



				var conf = {
					"local_root": path,
					"local_root_path": physicalPath,
					"size_limit": sizeLimit,
					"upload_limit": uploadLimit,
					"download_limit": downloadLimit,
					"upload": enableUpload,
					"download": enableDownload,
					"delete_remote": deleteRemote,
					"delete_local": deleteLocal,
					"filter_extname": filterExtName,
					//"filter_name": filterName,
					"user_def_extname": userDefExtName,
					"filter_path": serverPath
				};

				AS.ARC.ajax({
					url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act: 'set_conf', conf: JSON.stringify(conf)}),
					method: 'post',
					success: function (json, opts) {
						settingTabPanel.el.unmask();
						btn.enable();
						location.setValue(path);
						settingTabPanel.close();
					},
					failure: function (json, opts) {
						fn.settingTabPanel.el.unmask();
						btn.enable();
						settingTabPanel.close();
					}
				});
			}
			
		});
		
		var getFileBrowse = function() {
			
			
			var savePath = Ext.create('Ext.form.field.Text', {
				itemId: 'path_df',
				dirtyPath: false,
				width: 390,
				//labelWidth: AS.ARC.config.layout.defaultLabelWidth,
				//fieldLabel: _S('GOOGLE_DRIVE', 'SYNC_FOLDER'),
				value: AS.ARC.datas.defaultValue,
				readOnly: true,
				allowBlank: false,
				blankText: _S('MESSAGE', 'HF00011')
			});

			var browseBtn = Ext.create(Ext.button.Button, {
				itemId: 'browse',
				margin: '0 0 0 10',
				text: _S('COMMON', 'BROWSE'),
				handler: function () {
					var fs = Ext.create('AS.ARC.treeSelector', {
						hideReadOnly: true,
						parentWin: settingTabPanel,
						objectPath: savePath,
						isShowHome: true,

					});
					fs.win.show();
				}
			});


			var ct = Ext.create(Ext.form.FieldSet, {
				itemId: 'path-ct',
				title: _S('ONEDRIVE', 'PLEASE_SELECT_LOCAL_FOLDER'),
				layout: 'hbox',
				style: 'margin-top: 5px;',
				items: [
					savePath,
					browseBtn
				]
			});

			return ct;
		
		};
		
		var serverTreeTab = Ext.create(AS.ARC.fnFormPanel, {
			itemId: 'serverTreeTab',
			page: fn,
			cls: 'as-page-panel',
			title: _S('ONEDRIVE', 'FOLDER_SETTINGS'),
			padding: '5 15 15 15',
			items: [
				getFileBrowse(),
				{
					xtype: 'fieldset',
					itemId: 'fs',
					title: _S('ONEDRIVE', 'DO_NOT_SYNC_FOLDER'),
					style: 'margin-top: 5px;',
					border: false,
					//width: 533,
					height: 300,
					items: [
						fn.getServerTree(applyBtn)
					]
				},
				{
					xtype: 'displayfield',
					itemId: 'path',
					hidden: true
				}
			]
		});
		
		var filterPanel = fn.getFilterPanel();
		var configPanel = fn.getConfigPanel();
        var sizeLimit =  filterPanel.items.get('size_limit');
		var uploadLimit = configPanel.items.get('fs1').items.get('upload_limit');
		var downloadLimit = configPanel.items.get('fs1').items.get('download_limit');
        sizeLimit.on('validitychange', applyValidator);
		uploadLimit.on('validitychange', applyValidator);
		downloadLimit.on('validitychange', applyValidator);
		
		var filterTab = Ext.create(AS.ARC.fnFormPanel, {
			itemId: 'filterTab',
			page: fn,
			cls: 'as-page-panel',
			title: _S('ONEDRIVE', 'FILE_FILTER'),
			padding: '10 15 15 15',
			items: [
				filterPanel
			]
		});
		
		var configTab = Ext.create(AS.ARC.fnFormPanel, {
			itemId: 'configTab',
			page: fn,
			cls: 'as-page-panel',
			title: _S('COMMON', 'ADVANCED_SETTINGS'),
			padding: '15 15 15 15',
			items: [
				configPanel
			]
		});
		
		var tabPanel = Ext.create(Ext.tab.Panel, {
			itemId: 'settingTabPanel',
			width: 575,
			height: 510,
			items: [
				serverTreeTab,
				filterTab,
				configTab
			]
		});
		
		
		var settingTabPanel = Ext.create('AS.ARC.subWindow', {
			title: _S('COMMON', 'SETTINGS'),
			width: 575,
			height: 510,
			parentWin: fn.win,
			activeItem: 0,
			items: [
				tabPanel
			],
			fbar: [
				applyBtn,
				{
					xtype: 'button',
					itemId: 'cancel',
					text: _S('COMMON', 'CANCEL'),
					handler: function () {
						settingTabPanel.close();
						fn.win.el.unmask();
					}
				}
			],
			listeners: {
				afterrender: function() {
					
					var filterPanel = settingTabPanel.items.get('settingTabPanel').items.get('filterTab').items.get('filterPanel');
					var filterSet = filterPanel.items.get('filterSet');
					var documentCt = filterSet.items.get('documentCt');
					var videoCt = filterSet.items.get('videoCt');
					var musicCt = filterSet.items.get('musicCt');
					var photoCt = filterSet.items.get('photoCt');
					var applicationCt = filterSet.items.get('applicationCt');
					var customCt = filterSet.items.get('customCt');	
					var documentCbs = filterSet.items.get('documentCt').items.get('ct2').query('checkbox');
					var videoCbs = filterSet.items.get('videoCt').items.get('ct2').query('checkbox');
					var musicCbs = filterSet.items.get('musicCt').items.get('ct2').query('checkbox');
					var photoCbs = filterSet.items.get('photoCt').items.get('ct2').query('checkbox');
					var applicationCbs = filterSet.items.get('applicationCt').items.get('ct2').query('checkbox');
					var customCbs = filterSet.items.get('customCt').items.get('ct2').query('checkbox');
					var path = settingTabPanel.items.get('settingTabPanel').items.get('serverTreeTab').items.get('path-ct').items.get('path_df');
					var configPanel = settingTabPanel.items.get('settingTabPanel').items.get('configTab').items.get('configPanel');
					var sizeLimit = filterPanel.items.get('size_limit')
					var uploadLimit = configPanel.items.get('fs1').items.get('upload_limit');
					var downloadLimit = configPanel.items.get('fs1').items.get('download_limit');
					var enableUpload = configPanel.items.get('fs2').items.get('enable_upload');
					var deleteRemote = configPanel.items.get('fs2').items.get('delete_remote');
					var enableDownload = configPanel.items.get('fs2').items.get('enable_download');
					var deleteLocal = configPanel.items.get('fs2').items.get('delete_local');
					var radiogroup = configPanel.items.get('fs2').query('radiogroup')[0];
					
					AS.ARC.ajax({
							url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act: 'get_conf'}),
							method: 'post',
							success: function (json, opts) {
								
								if (json.conf.user_def_extname.length != 0) {
									
									for (var i = 0; i < json.conf.user_def_extname.length; i ++) {
										filterSet.items.get('customCt').items.get('ct2').add(
											{
												xtype: 'container',
												layout: 'hbox',
												style: '',
												width: 430,
												items: [
													
													{
														xtype: 'checkbox',
														style: '',
														boxLabel: json.conf.user_def_extname[i],
														handler: function(checkbox, checked) {

															var selectAllCb = checkbox.ownerCt.ownerCt.ownerCt.items.get('ct1').items.get('select_all');
															var checkAllTrue = true;
															var checkCount = 0;
															selectAllCb.removeCls('gray-checkbox');
															for (var i = 0; i < checkbox.ownerCt.ownerCt.query('checkbox').length; i ++) {
																if (!checkbox.ownerCt.ownerCt.query('checkbox')[i].getValue()) {
																	checkAllTrue = false;
																} else {
																	checkCount += 1;
																}
															}
															if (checkAllTrue == true) {
																selectAllCb.setValue(true);
															} else {
																if(checkCount) {
																	selectAllCb.addCls('gray-checkbox');
																}
																selectAllCb.setRawValue(false);
																selectAllCb.lastValue = false;
															}
														},
														listeners: {
															afterrender: function(checkbox) {
																if (json.conf.filter_extname.length != 0) {
																	for (var i = 0; i < json.conf.filter_extname.length; i ++) {
																		if (json.conf.filter_extname[i] == checkbox.boxLabel) {
																			checkbox.setValue(true);
																		}
																	}
																}
															}
														}
													},
													{
														xtype: 'tbfill'
													},
													{
															xtype: 'image',
															width: 17,
															height: 17,
															style: 'cursor: pointer;',
															src: fn.imageUrl + 'close.png',
															listeners: {
															render: function(img) {
																img.getEl().on('click', function() {
																	filterSet.items.get('customCt').items.get('ct2').remove(img.ownerCt, true);
																});
															}
														}
													}
												]
											}
										);
										
									}
								}
								
								
								if (json.conf.filter_extname.length != 0) {
									
									for(var i = 0; i < json.conf.filter_extname.length; i ++) {
										
										for (var j = 0; j < documentCbs.length; j ++) {
											if (json.conf.filter_extname[i] == documentCbs[j].boxLabel) {
												documentCbs[j].setValue(true);
											}
										}

										for (var j = 0; j < videoCbs.length; j ++) {
											if (json.conf.filter_extname[i] == videoCbs[j].boxLabel) {
												videoCbs[j].setValue(true);
											}
										}

										for (var j = 0; j < musicCbs.length; j ++) {
											if (json.conf.filter_extname[i] == musicCbs[j].boxLabel) {
												musicCbs[j].setValue(true);
											}
										}

										for (var j = 0; j < photoCbs.length; j ++) {
											if (json.conf.filter_extname[i] == photoCbs[j].boxLabel) {
												photoCbs[j].setValue(true);
											}
										}

										for (var j = 0; j < applicationCbs.length; j ++) {
											if (json.conf.filter_extname[i] == applicationCbs[j].boxLabel) {
												applicationCbs[j].setValue(true);
											}
										}
										
										for (var j = 0; j < customCbs.length; j ++) {
											if (json.conf.filter_extname[i] == customCbs[j].boxLabel) {
												customCbs[j].setValue(true);
											}
										}

									}
								}
								

								
								sizeLimit.setValue(json.conf.size_limit);
								uploadLimit.setValue(json.conf.upload_limit);
								downloadLimit.setValue(json.conf.download_limit);
								enableUpload.setValue(json.conf.upload);
								enableDownload.setValue(json.conf.download);
								deleteRemote.setValue(json.conf.delete_remote);
								deleteLocal.setValue(json.conf.delete_local);
								path.setValue(json.conf.local_root);
								
								
								if (json.conf.upload && json.conf.download) {
									radiogroup.items.items[0].setValue(true);
								} else if (json.conf.download && !json.conf.upload) {
									radiogroup.items.items[1].setValue(true);
									deleteLocal.show();
								} else if (!json.conf.download && json.conf.upload) {
									radiogroup.items.items[2].setValue(true);
									deleteRemote.show();
								}
								
								
							},
							failure: function (json, opts) {
								
							}
						});
				}
			}
		});
		
		settingTabPanel.show();
	},

	getMainPanel: function() {
		var fn = this;
		
		fn.mainPanel = Ext.create('Ext.container.Container', {
			cls: 'as-page-panel',
			region: 'center',
			height: 500,
			width: 845,
			border: false,
			layout: {
				type: 'card'
			},
			activeItem: 0,
			items: [
				fn.getLoginPanel(),
				fn.getSettingPanel(),
				fn.getAccountPanel()
			],
			loadData: function () {
				fn.checkLogin(true);
				fn.win.el.mask();
			}
		});
		return fn.mainPanel;
	}

});


/**
 * @class AS.ARC.apps.onedrive.main
 * @extends AS.ARC._appBase
 *<p>Main app</p>
 */

Ext.define('AS.ARC.apps.onedrive.main', {
	extend: 'AS.ARC._appBase',

	appTag: 'onedrive',
	title: 'One Drive',
	appMaxNum: 1,
	appOpenNum: 0,
	appIsReady: true,
	appWins: [],

	createWindow: function () {
		var desktop = this.core.getDesktop(),
			app = this;

		if ((this.appOpenNum === this.appMaxNum) || !this.appIsReady) {
			this.appWins[0].show();
			return;
		}

		// Set appIsReady to false
		this.appIsReady = false;

		var newOneDrive = new AS.ARC.apps.onedrive.core({
			app: this,
			desktop: desktop,
			id: this.id + '-' + Ext.id()
		});

		newOneDrive.win.on('beforeclose', function () {
			app.appOpenNum--;
			app.appIsReady = true;
			app.appWins.pop();
			clearTimeout(newOneDrive.userInfo);
			clearTimeout(newOneDrive.status);
		});
		newOneDrive.win.show();

		// Get all wins for handling
		this.appWins.push(newOneDrive.win);
	},
	onClose: function () {

	}

});